image: python:3

stages:
  - tests
  - deploy
  - validate

utests:
  stage: tests
  script:
    - pip3 install -r requirements.txt
    - python3 -m unittest discover -s project -v -p test_*.py

dtests:
  stage: tests
  variables:
    INFRA_TP5_DB_TYPE: SQLite
  script:
    - pip3 install -r requirements.txt
    - ./run.sh project/myAPI/api.py &
    - sleep 5
    - python3 -m unittest discover -s project -v -p dtest_*.py

deployProd:
  stage: deploy
  script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY_AWS" | base64 -d)
    - ssh-add <(echo "$SSH_PRIVATE_KEY_AWS_GIT")
    - mkdir -p ~/.ssh/ 
    - echo -e "Host $AWS_EC2_IP \n\tForwardAgent yes" > ~/.ssh/config
    - more ~/.ssh/config
    - ssh -o StrictHostKeyChecking=no ubuntu@$AWS_EC2_IP "cd /home/ubuntu/infrah2021tp5startingpoint/ &&
        git fetch origin master && git reset --hard origin/master && exit"
  only:
    refs:
      - master


vtests:
  stage: validate
  script:
    - pip install requests
    - python3 -m unittest discover -s project -v -p vtest_*.py
  only:
    refs:
      - master

